# 	$Id: initscripts.spec 252003 2009-01-22 17:26:21Z eugeni $	

# The restart part in the real _post_service doesn't work with netfs and isn't needed
# for other scripts
%define _mypost_service() if [ $1 = 1 ]; then /sbin/chkconfig --add %{1}; fi;

%define with_upstart 0
%define with_systemd 0

Summary: The inittab file and the /etc/init.d scripts
Name: initscripts
Version: 9.26
Release: %mkrel 44
License: GPLv2 and GPLv2+
Group: System/Base
Source0: initscripts-%{version}.tar.xz
Source1: rc.sysinit
Source2: functions
Source3: halt
Source4: mandrake_everytime
Source5: rc.local
Source6: rc
Source7: network
Source8: prefdm
Source9: touchpadfix
Source10: sysctl.conf
Source11: dm

Patch0:     initscripts-mdkconf.patch
Patch2:     initscripts925_console_check.patch
Patch3:     initscripts925_network_functions.patch
Patch4:     initscripts925_sync_10.patch
Patch5:     initscripts925_network_up3.patch
Patch6:     initscripts925_ifup-eth_use_new_variables.patch
Patch7:     initscripts925_ifup-wireless_use_new_variables.patch
Patch8:     initscripts925_nm_ifupdown.patch
Patch9:     initscripts925_nm_ifupdown_eth_mga.patch
Patch10:    initscripts925_init_ipv6_global.patch
Patch11:	initscripts925_console_check-fixbuild.patch
Patch12:	initscripts925_ifupdown_eth_dhcpcd.patch

BuildRoot: /%{_tmppath}/%{name}-%{version}-%{release}-root

Requires: mingetty
Requires: gawk
Requires: sed
Requires: mktemp
Requires: e2fsprogs
Requires: procps
Requires: gettext-base
Requires: module-init-tools
Requires: kbd
Requires: psmisc
Requires: which
Requires: setup
Requires: SysVinit
Requires: iproute2
Requires: iputils
Requires: net-tools
Requires: findutils
Requires: sysvinit-tools
Requires: perl-MDK-Common
Requires: ifplugd
Requires: ethtool
Obsoletes: rhsound sapinit
Provides: rhsound sapinit
Requires: util-linux-ng
Requires: mount
Requires: udev
Requires: ifmetric
Requires: resolvconf
Requires: dmsetup
Requires: prcsys
Requires: sd
Requires: iw
Requires(post): /usr/bin/tr grep, chkconfig
BuildRequires: glib2-devel
BuildRequires: pkgconfig
BuildRequires: lib64popt-devel
BuildRequires: python
URL: http://pclinuxos.com

#this is required since latest glibc (new atomic OPs?)
%define _requires_exceptions GLIBC_PRIVATE


%description
The initscripts package contains the basic system scripts used to boot
your PCLINUXOS system, change run levels, and shut the system
down cleanly.  Initscripts also contains the scripts that activate and
deactivate most network interfaces.

%package -n debugmode
Summary: Scripts for running in debugging mode
Requires: initscripts
Group: System/Base

%description -n debugmode
The debugmode package contains some basic scripts that are used to run
the system in a debugging mode.

Currently, this consists of various memory checking code.

%prep
%setup -q
rm -rf po
%patch2  -p1
%patch0  -p0
%patch3  -p1
%patch4  -p1
%patch5  -p1
%patch6  -p1
%patch8  -p1
%patch9  -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1

#even if iw is better in many ways we still use wpa-supplicant cause.. NEVER failed
#patch7 -p1

rm -f po
ln -s mandriva/po

gzip -9 mandriva/ChangeLog
mv ChangeLog ChangeLog-RH
gzip -9 ChangeLog-RH

%build
make
make -C mandriva CFLAGS="$RPM_OPT_FLAGS"

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc
make ROOT=$RPM_BUILD_ROOT SUPERUSER=`id -un` SUPERGROUP=`id -gn` mandir=%{_mandir} install

#MDK
make -C mandriva install ROOT=$RPM_BUILD_ROOT mandir=%{_mandir}

python mandriva/gprintify.py \
	`find %{buildroot}/etc/rc.d -type f` \
	`find %{buildroot}/sysconfig/network-scripts -type f` \
	%{buildroot}/lib/systemd/fedora-* \
	%{buildroot}/lib/systemd/mandriva-*

%find_lang %{name}

 mv -f $RPM_BUILD_ROOT/etc/inittab.sysv $RPM_BUILD_ROOT/etc/inittab
 rm -rf $RPM_BUILD_ROOT/etc/event.d
 rm -rf $RPM_BUILD_ROOT/etc/init
 rm -f $RPM_BUILD_ROOT/etc/inittab.*

%ifnarch s390 s390x
rm -f \
 $RPM_BUILD_ROOT/etc/sysconfig/network-scripts/ifup-ctc \
 $RPM_BUILD_ROOT/etc/sysconfig/network-scripts/ifup-iucv \
 $RPM_BUILD_ROOT/lib/udev/rules.d/55-ccw.rules \
 $RPM_BUILD_ROOT/lib/udev/ccw_init
%else
rm -f \
 $RPM_BUILD_ROOT/etc/rc.d/rc.sysinit.s390init \
 $RPM_BUILD_ROOT/etc/sysconfig/init.s390
%endif

# remove unused hotplug helper and ipsec/isdn stuff
rm -f $RPM_BUILD_ROOT/etc/sysconfig/network-scripts/{ifdown-ippp,ifup-ippp,ifdown-ipsec,ifup-ipsec,net.hotplug}

# we use network rules from the udev package
rm -f $RPM_BUILD_ROOT/lib/udev/rules.d/60-net.rules

#remove conflicting file with ppp pkg
rm -f $RPM_BUILD_ROOT/usr/share/man/man8/ppp-watch.8*

# we have our own copy of gprintify
export DONT_GPRINTIFY=1

# install custom rc.sysinit file
install -m 0755 %SOURCE1 $RPM_BUILD_ROOT/etc/rc.d/rc.sysinit

# install custom functions file
install -m 0644 %SOURCE2 $RPM_BUILD_ROOT/etc/rc.d/init.d

# install custom halt file
install -m 0755 %SOURCE3 $RPM_BUILD_ROOT/etc/rc.d/init.d

# install custom mandrake_everytime file
install -m 0755 %SOURCE4 $RPM_BUILD_ROOT/etc/rc.d/init.d

# install custom rc.local
install -m 0755 %SOURCE5 $RPM_BUILD_ROOT/etc/rc.d/rc.local

# install custom network
install -m 0755 %SOURCE6 $RPM_BUILD_ROOT/etc/rc.d/rc

#install custom rc
install -m 0755 %SOURCE7 $RPM_BUILD_ROOT/etc/rc.d/init.d/network

#install updated prefdm for lxdm support
install -m 0755 %SOURCE8 $RPM_BUILD_ROOT/etc/X11/prefdm

#install custom sysctl.conf
install -m 0644 %SOURCE10 $RPM_BUILD_ROOT/etc/sysctl.conf

# umount /media/* when stopping dm to clean mounted folders
install -m 0755 %SOURCE11  $RPM_BUILD_ROOT/etc/rc.d/init.d/dm

%if !%{with_systemd}
 rm -rf $RPM_BUILD_ROOT/lib/systemd
%endif

install -d -m 0755 %{buildroot}/%{_sysconfdir}/sysctl.d

# install touchpadfix.sh
install -d -m 755 $RPM_BUILD_ROOT%{_sbindir}
install -m 755 %SOURCE9 $RPM_BUILD_ROOT%{_sbindir}/touchpadfix.sh

%post
##Fixme
touch /etc/sysconfig/i18n
##
touch /var/log/wtmp /var/run/utmp /var/log/btmp
chown root:utmp /var/log/wtmp /var/run/utmp /var/log/btmp
chmod 664 /var/log/wtmp /var/run/utmp
chmod 600 /var/log/btmp

%_mypost_service partmon

%_mypost_service network

%_mypost_service network-up

%_mypost_service dm

%_mypost_service netconsole

%_mypost_service netfs

# /etc/sysconfig/desktop format has changed
if [ -r /etc/sysconfig/desktop ]; then
    if ! grep -q = /etc/sysconfig/desktop; then
        DESK=`cat /etc/sysconfig/desktop`
        echo "DESKTOP=$DESK" > /etc/sysconfig/desktop
    fi
fi

# Add right translation file
for i in `echo $LANGUAGE:$LC_ALL:$LC_COLLATE:$LANG:C | tr ':' ' '`
do
	if [ -r %{_datadir}/locale/$i/LC_MESSAGES/initscripts.mo ]; then
		mkdir -p /etc/locale/$i/LC_MESSAGES/
		cp %{_datadir}/locale/$i/LC_MESSAGES/initscripts.mo \
			/etc/locale/$i/LC_MESSAGES/
                #
		# warly
		# FIXME: this should be done by each locale when installed or upgraded
		#
		pushd %{_datadir}/locale/$i/ > /dev/null && for j in LC_*
		do
			if [ -r $j -a ! -d $j ]; then
			    cp $j /etc/locale/$i/
			fi
		done && popd > /dev/null
		if [ -r %{_datadir}/locale/$i/LC_MESSAGES/SYS_LC_MESSAGES ]; then
			cp %{_datadir}/locale/$LANG/LC_MESSAGES/SYS_LC_MESSAGES /etc/locale/$i/LC_MESSAGES/
		fi
		#
		#
		break
	fi
done

%define initlvl_chg() if [[ -f /etc/rc3.d/S%{2}%{1} ]] && [[ -f /etc/rc5.d/S%{2}%{1} ]] && egrep -q 'chkconfig: [0-9]+ %{3}' /etc/init.d/%{1}; then chkconfig --add %{1} || : ; fi; \
%{nil}

# only needed on upgrade
if [ $1 != 0 ]; then
	# handle the switch to an independant prefdm initscript
	if grep -q '^x:5' /etc/inittab; then
		rm -f /etc/inittab.new
		sed 's/x:5/#x:5/' < /etc/inittab > /etc/inittab.new
		mv -f /etc/inittab.new /etc/inittab
		chkconfig --add dm || :
	fi

	# handle single user mode declaration
	if ! grep -q '..:S:' /etc/inittab; then
		cat >> /etc/inittab <<EOF

# Single user mode
~~:S:wait:/bin/sh
EOF
	fi
	
	# Handle boot sequence changes on upgrade
	%initlvl_chg partmon 80 13
	
fi

%pre
#backup custom rc.local folder
sd "/usr/sbin/alsaunmute" "#/usr/sbin/alsaunmute" /etc/rc.d/rc.local
cp /etc/rc.d/rc.local /opt/rc.local.bakup
rm -f /etc/rc.d/rc.local
rm -f /etc/sysctl.conf
#replace mandrake_everytime on install
rm -f /etc/rc.d/init.d/mandrake_everytime
# disable checking for new hardware in mandrake_everytime
rm -f /etc/sysconfig/harddrake2/*
rm -f /etc/rc.d/init.d/halt

%preun
%_preun_service netfs

%_preun_service netconsole

%_preun_service dm

%_preun_service network-up

%_preun_service network

%_preun_service partmon

%triggerun -- initscripts < 7.62
/sbin/chkconfig --del random
/sbin/chkconfig --del rawdevices
exit 0

%postun
if [ -f /var/lock/TMP_1ST ];then
		rm -f /var/lock/TMP_1ST
fi
if [ "$1" = "0" ]; then
	for i in /etc/locale/*/LC_MESSAGES/initscripts.mo
	do
		rm -f $i
		rmdir `dirname $i` >/dev/null 2> /dev/null
	done
	rmdir /etc/locale/* >/dev/null 2> /dev/null
fi

%posttrans
if [ -f /etc/inittab.rpmsave ];then 
mv /etc/inittab.rpmsave /etc/inittab
fi 

if [ -f /etc/inittab.rpmnew ];then 
rm -rf /etc/inittab.rpmnew
fi 

#restore backed up rc.local file
cp /opt/rc.local.bakup /etc/rc.d/rc.local

#convert
sd "/bin/sh" "/bin/bash" /etc/rc.d/init.d/*

%clean
rm -rf $RPM_BUILD_ROOT

%files -f %{name}.lang
%defattr(-,root,root)
%dir /etc/sysconfig/network-scripts
%dir /etc/sysconfig/network-scripts/ifup.d
%dir /etc/sysconfig/network-scripts/ifdown.d
%dir /etc/sysconfig/network-scripts/wireless.d
%dir /etc/sysconfig/network-scripts/vpn.d
%dir /etc/sysconfig/network-scripts/vpn.d/openvpn
%dir /etc/sysconfig/network-scripts/vpn.d/pptp
%dir /etc/sysconfig/network-scripts/vpn.d/vpnc
%config(noreplace) %verify(not md5 mtime size) /etc/adjtime
%config(noreplace) /etc/sysconfig/init
%config(noreplace) /etc/sysconfig/autofsck
%config(noreplace) /etc/sysconfig/partmon
%config(noreplace) /etc/sysconfig/netconsole
%config(noreplace) /etc/sysconfig/readonly-root
%config(noreplace) /etc/sysconfig/speedboot
/etc/sysconfig/network-scripts/ifdown
/sbin/ifdown
/etc/sysconfig/network-scripts/ifdown-post
/etc/sysconfig/network-scripts/ifup
/sbin/ifup
%{_sbindir}/touchpadfix.sh
%dir /etc/sysconfig
%dir /etc/sysconfig/console
%dir /etc/sysconfig/console/consoletrans
%dir /etc/sysconfig/console/consolefonts
%dir /etc/sysconfig/modules
%dir /etc/sysconfig/networking
%dir /etc/sysconfig/networking/devices
%dir /etc/sysconfig/networking/profiles
%dir /etc/sysconfig/networking/profiles/default
/etc/sysconfig/network-scripts/network-functions
/etc/sysconfig/network-scripts/network-functions-ipv6
/etc/sysconfig/network-scripts/init.ipv6-global
%config(noreplace) /etc/sysconfig/network-scripts/ifcfg-lo
/etc/sysconfig/network-scripts/ifup-ipx
/etc/sysconfig/network-scripts/ifup-post
/etc/sysconfig/network-scripts/ifdown-ppp
/etc/sysconfig/network-scripts/ifup-ppp
/etc/sysconfig/network-scripts/ifup-routes
/etc/sysconfig/network-scripts/ifdown-routes
/etc/sysconfig/network-scripts/ifup-plip
/etc/sysconfig/network-scripts/ifup-plusb
/etc/sysconfig/network-scripts/ifup-bnep
/etc/sysconfig/network-scripts/ifdown-bnep
/etc/sysconfig/network-scripts/ifup-eth
/etc/sysconfig/network-scripts/ifdown-eth
/etc/sysconfig/network-scripts/ifup-ipv6
/etc/sysconfig/network-scripts/ifdown-ipv6
/etc/sysconfig/network-scripts/ifup-sit
/etc/sysconfig/network-scripts/ifdown-sit
/etc/sysconfig/network-scripts/ifup-tunnel
/etc/sysconfig/network-scripts/ifdown-tunnel
/etc/sysconfig/network-scripts/ifup-aliases
#/etc/sysconfig/network-scripts/ifup-ippp
#/etc/sysconfig/network-scripts/ifdown-ippp
/etc/sysconfig/network-scripts/ifup-wireless
/etc/sysconfig/network-scripts/ifup-hso
/etc/sysconfig/network-scripts/ifdown-hso
/etc/X11/prefdm
/etc/X11/lookupdm
%dir /etc/X11/xsetup.d
/etc/X11/xsetup.d/90speedboot.xsetup
%config(noreplace) /etc/networks 
/etc/rwtab
%dir /etc/rwtab.d
/etc/statetab
%dir /etc/statetab.d
%if %{with_upstart}
%config(noreplace) /etc/event.d/*
/etc/init/*
%endif
/lib/udev/rules.d/*
%config(noreplace) /etc/inittab
%config(noreplace missingok) /etc/rc.d/rc[0-9].d/*
/etc/rc[0-9].d
/etc/rcS.d
/etc/rc
%dir /etc/rc.d/init.d
/etc/rc.local
/etc/rc.sysinit
/lib/lsb/init-functions
/etc/rc.d/init.d/*
/etc/rc.d/rc
/etc/rc.d/rc.local
/etc/rc.d/rc.sysinit
/etc/sysctl.conf
%dir /etc/sysctl.d
%exclude /etc/profile.d/debug*
%config /etc/profile.d/*
%dir /etc/sysconfig/network-scripts/cellular.d
%dir /etc/sysconfig/network-scripts/hostname.d
/etc/sysconfig/network-scripts/ifup.d/vpn
/etc/sysconfig/network-scripts/ifdown.d/vpn
/usr/sbin/vpn-start
/usr/sbin/vpn-stop
/usr/sbin/mdv-network-event
/usr/sbin/sys-unconfig
/bin/ipcalc
/bin/usleep
%attr(4755,root,root) /usr/sbin/usernetctl
/sbin/consoletype
/sbin/fstab-decode
/sbin/genhostid
/sbin/getkey
/sbin/securetty
%attr(2755,root,root) /sbin/netreport
/lib/udev/rename_device
/lib/udev/console_init
/lib/udev/console_check
%ifarch s390 s390x
/lib/udev/ccw_init
%endif
/sbin/service
/sbin/sushell
#mdv
/sbin/hibernate-cleanup.sh
/sbin/ppp-watch
%{_mandir}/man*/*
%lang(cs)	%{_mandir}/cs/man*/*
%lang(et)	%{_mandir}/et/man*/*
%lang(fi)	%{_mandir}/fi/man*/*
%lang(fr)	%{_mandir}/fr/man*/*
%lang(it)	%{_mandir}/it/man*/*
%lang(pt_BR)	%{_mandir}/pt_BR/man*/*
%lang(ru)	%{_mandir}/ru/man*/*
%lang(uk)	%{_mandir}/uk/man*/*
%dir %attr(775,root,root) /var/run/netreport
%dir /etc/ppp
%dir /etc/ppp/ip-down.d
%dir /etc/ppp/ip-up.d
%dir /etc/ppp/peers
/etc/ppp/ip-up
/etc/ppp/ip-down
/etc/ppp/ip-up.ipv6to4
/etc/ppp/ip-down.ipv6to4
/etc/ppp/ipv6-up
/etc/ppp/ipv6-down
%dir /etc/NetworkManager
%dir /etc/NetworkManager/dispatcher.d
/etc/NetworkManager/dispatcher.d/00-netreport
/etc/NetworkManager/dispatcher.d/05-netfs
%doc sysconfig.txt sysvinitfiles mandriva/ChangeLog.gz ChangeLog-RH.gz static-routes-ipv6 ipv6-tunnel.howto ipv6-6to4.howto changes.ipv6
/var/lib/stateless
%dir /var/lib/speedboot
%ghost %attr(0664,root,utmp) /var/log/btmp
%ghost %attr(0664,root,utmp) /var/log/wtmp
%ghost %attr(0664,root,utmp) /var/run/utmp
%config(noreplace) /etc/modules
/etc/rc.modules
%dir /etc/modprobe.preload.d/
%ifnarch %{sunsparc}
/usr/sbin/supermount
%endif
/usr/bin/*
%if %{with_systemd}
/lib/systemd/fedora-autorelabel
/lib/systemd/fedora-autoswap
/lib/systemd/fedora-configure
/lib/systemd/fedora-loadmodules
/lib/systemd/fedora-readonly
/lib/systemd/fedora-storage-init
/lib/systemd/mandriva-boot-links
/lib/systemd/mandriva-save-dmesg
/lib/systemd/system/basic.target.wants/fedora-autorelabel.service
/lib/systemd/system/basic.target.wants/fedora-autoswap.service
/lib/systemd/system/basic.target.wants/fedora-configure.service
/lib/systemd/system/basic.target.wants/fedora-loadmodules.service
/lib/systemd/system/basic.target.wants/fedora-sysinit-hack.service
/lib/systemd/system/basic.target.wants/mandriva-boot-links.service
/lib/systemd/system/basic.target.wants/mandriva-everytime.service
/lib/systemd/system/basic.target.wants/mandriva-save-dmesg.service
/lib/systemd/system/ctrl-alt-del.target
/lib/systemd/system/fedora-autorelabel.service
/lib/systemd/system/fedora-autoswap.service
/lib/systemd/system/fedora-configure.service
/lib/systemd/system/fedora-loadmodules.service
/lib/systemd/system/fedora-readonly.service
/lib/systemd/system/fedora-storage-init.service
/lib/systemd/system/fedora-sysinit-hack.service
/lib/systemd/system/fedora-sysinit-unhack.service
/lib/systemd/system/fedora-wait-storage.service
/lib/systemd/system/mandriva-boot-links.service
/lib/systemd/system/mandriva-clean-var-run-lock.service
/lib/systemd/system/mandriva-everytime.service
/lib/systemd/system/mandriva-save-dmesg.service
/lib/systemd/system/local-fs.target.wants/fedora-readonly.service
/lib/systemd/system/local-fs.target.wants/fedora-storage-init.service
/lib/systemd/system/mandriva-kmsg-loglevel.service
/lib/systemd/system/multi-user.target.wants/fedora-sysinit-unhack.service
/lib/systemd/system/sysinit.target.wants/mandriva-clean-var-run-lock.service
/lib/systemd/system/sysinit.target.wants/mandriva-kmsg-loglevel.service
/etc/tmpfiles.d/initscripts.conf
/etc/tmpfiles.d/mandriva.conf
%endif

%files -n debugmode
%config(noreplace) /etc/sysconfig/debug
%config /etc/profile.d/debug*
/etc/tmpfiles.d/initscripts.conf
/etc/tmpfiles.d/mandriva.conf

%changelog
* Tue Apr 23 2024 yodelu - 9.25-44pclos2024
- rediff p3 networkmanager > NetworkManager

* Thu Mar 14 2024 tex - 9.25-43pclos2024
- hack to create /var/run/user/1000 at boot

* Thu Feb 08 2024 yodelu - 9.25-42pclos2024
- add p12 >> ifup-eth/ifdown-eth fixes for dhcpcd

* Sat Jan 06 2024 yodelu - 9.25-41pclos2024
- don't kill unionfs (avoid hangs on halt/reboot)

* Sun Dec 31 2023 yodelu - 9.25-40pclos2024
- clean up halt/reboot scripts due
	dropped mtab support in util-linux > 2.38
- add p11 - fix build on latest kernel(s)
- when call halt do poweroff if possible (-p)

* Sat Aug 12 2023 tex - 9.25-39pclos2023
- clean up leftover /var/lock/subsytem folder in halt script

* Sun Jul 30 2023 tex - 9.25-38pclos2023
- fix rtw89_8852ae wireless driver working at boot
- of the live media

* Fri Jul 07 2023 tex - 9.25-37pclos2023
- unmount /boot/EFI on shutdown if directory exists
- to avoid dirty bit

